#include <arch/pirq_routing.h>

const struct irq_routing_table ppc_irq_routing_table = {
	PIRQ_SIGNATURE,	/* u32 signature */
	PIRQ_VERSION,	/* u16 version   */
	32+16*9,	/* u16 Table size 32+(16*devices) */
	0x00,		/* u8 Bus 0 */
	0xf8,		/* u8 Device 1, Function 0 */
	0x0000,		/* u16 reserve IRQ for PCI */
	0x1057,		/* u16 Vendor - Motorola */
	0x0004,		/* Device ID - MPC107 */
	0x00000000,	/* u32 miniport_data */
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, /* u8 rfu[11] */
	IRQ_CHECKSUM,	/*  u8 checksum - mod 256 checksum must give zero */
	{  /* bus, devfn, {link, bitmap}, {link, bitmap}, {link, bitmap}, {link, bitmap}, slot, rfu  */
	    {0x00, 0x10, {{0x62, 0xdeb8}, {0x62, 0xdeb8}, {0x62, 0xdeb8}, {0x62, 0xdeb8}}, 0x00,  0x00},
	    {0x04, 0x40, {{0x68, 0xdeb8}, {0x69, 0xdeb8}, {0x6a, 0xdeb8}, {0x6b, 0xdeb8}}, 0x01,  0x00},
	    {0x04, 0x38, {{0x60, 0xdeb8}, {0x61, 0xdeb8}, {0x62, 0xdeb8}, {0x63, 0xdeb8}}, 0x02,  0x00},
	    {0x04, 0x08, {{0x61, 0xdeb8}, {0x62, 0xdeb8}, {0x63, 0xdeb8}, {0x60, 0xdeb8}}, 0x03,  0x00},
	    {0x04, 0x10, {{0x62, 0xdeb8}, {0x63, 0xdeb8}, {0x60, 0xdeb8}, {0x61, 0xdeb8}}, 0x04,  0x00},
	    {0x04, 0x18, {{0x63, 0xdeb8}, {0x60, 0xdeb8}, {0x61, 0xdeb8}, {0x62, 0xdeb8}}, 0x05,  0x00},
	    {0x04, 0x20, {{0x60, 0xdeb8}, {0x61, 0xdeb8}, {0x62, 0xdeb8}, {0x63, 0xdeb8}}, 0x06,  0x00},
	    {0x03, 0x20, {{0x60, 0xdeb8}, {0x61, 0xdeb8}, {0x62, 0xdeb8}, {0x63, 0xdeb8}}, 0x07,  0x00},
	    {0x00, 0xf8, {{0x60, 0xdeb8}, {0x61, 0xdeb8}, {0x6b, 0xdeb8}, {0x63, 0xdeb8}}, 0x08,  0x00}
	}
};
